Attribute VB_Name = "ContextMenu"
Option Explicit

Public Function QueryContextMenuVB(ByVal this As IContextMenu, ByVal hMenu As Long, ByVal indexMenu As Long, ByVal idCmdFirst As Long, ByVal idCmdLast As Long, ByVal uFlags As Long) As Long

    Dim sMenuItem As String
    Dim idCmd As Long
        idCmd = idCmdFirst
    Dim sAnimal As String
        sAnimal = Space(255)
    Dim ctxMenu As clsContextMenu
    
    Set ctxMenu = this
    
    If (uFlags And &HF) = CMF_NORMAL Then
        
        'Indicates a normal operation
        'This happens on a right-click-drag operation
        'Implement this for Drag and Drop handler
        
    ElseIf (uFlags And CMF_VERBSONLY) Then
        'This is a context menu for a shortcut item
        
        
    ElseIf (uFlags And CMF_EXPLORE) Then
        'Right click on file in explorer
        
        If ctxMenu.FileCount > 1 Then
            sMenuItem = "Bunches o' Animal noises"
        Else
            GetPrivateProfileString "Animal", _
                                    "Type", _
                                    "Unknown", _
                                    sAnimal, _
                                    Len(sAnimal), _
                                    ctxMenu.FileName
                                    
            sAnimal = Trim(sAnimal)
            sAnimal = Left$(sAnimal, Len(sAnimal) - 1)
            
            sMenuItem = sAnimal & " Noise"
        
        End If
        
        Call InsertMenu(hMenu, indexMenu, MF_STRING Or MF_BYPOSITION, idCmd, sMenuItem)
        idCmd = idCmd + 1
        indexMenu = indexMenu + 1
        
        'sMenuItem = "Another menu item"
        'Call InsertMenu(hMenu, indexMenu, MF_STRING Or MF_BYPOSITION, idCmd, sMenuItem)
        'idCmd = idCmd + 1
        'indexMenu = indexMenu + 1
        
        'etc. , etc., etc.
        '
        'Do not increment idCmd for seperators!
        'Always increment indexMenu
        
    ElseIf (uFlags And CMF_DEFAULTONLY) Then
        
        'Indicated a default action is being performed (typically a
        'user is double clicking on the file)
        
    Else
        
    End If

    Set ctxMenu = Nothing
    
    'Always return number of items added to the menu
    'indexMenu will equal that in this instance, but not
    'others....like adding to an existing context menu
    QueryContextMenuVB = indexMenu

End Function



